Index: connection.c
===================================================================
RCS file: /usr/local/cvsroot/psqlodbc/psqlodbc/connection.c,v
retrieving revision 1.97
diff -u -r1.97 connection.c
--- connection.c	20 Jul 2005 14:50:21 -0000	1.97
+++ connection.c	22 Jul 2005 14:46:32 -0000
@@ -2360,13 +2360,20 @@
 		CC_conninfo_init(&(rv->connInfo));
 		rv->stmts = (StatementClass **) malloc(sizeof(StatementClass *) * STMT_INCREMENT);
 		if (!rv->stmts)
+		{
+			free(rv);
 			return NULL;
+		}
 		memset(rv->stmts, 0, sizeof(StatementClass *) * STMT_INCREMENT);
 
 		rv->num_stmts = STMT_INCREMENT;
 		rv->descs = (DescriptorClass **) malloc(sizeof(DescriptorClass *) * STMT_INCREMENT);
 		if (!rv->descs)
+		{
+			free(rv->stmts);
+			free(rv);
 			return NULL;
+		}
 		memset(rv->descs, 0, sizeof(DescriptorClass *) * STMT_INCREMENT);
 
 		rv->num_descs = STMT_INCREMENT;
@@ -2857,6 +2864,7 @@
 	if((!res) || (res->status == PGRES_EMPTY_QUERY) )
 	{
 		QR_Destructor(res);
+		res = NULL;
 		goto cleanup;
 	}
 	else
@@ -3141,6 +3149,7 @@
 	{
 		CC_set_error(self, CONNECTION_COULD_NOT_RECEIVE, "Could not allocate memory for result set");
 		QR_Destructor(qres);
+		return NULL;
 	}
 	qres->status = PQresultStatus(pgres);
 	if( (PQresultStatus(pgres) == PGRES_COMMAND_OK) )
Index: convert.c
===================================================================
RCS file: /usr/local/cvsroot/psqlodbc/psqlodbc/convert.c,v
retrieving revision 1.126
diff -u -r1.126 convert.c
--- convert.c	15 Jul 2005 09:08:50 -0000	1.126
+++ convert.c	22 Jul 2005 14:46:33 -0000
@@ -1578,7 +1578,7 @@
 	while (qp->statement[qp->opos] != '\0' && qp->statement[qp->opos] != ch) \
 	{ \
 	    buf[c++] = qp->statement[qp->opos++]; \
-		if (c >= maxsize) \
+		if (c >= maxsize - 1) \
 			break; \
 	} \
 	if (qp->statement[qp->opos] == '\0') \
Index: info.c
===================================================================
RCS file: /usr/local/cvsroot/psqlodbc/psqlodbc/info.c,v
retrieving revision 1.121
diff -u -r1.121 info.c
--- info.c	13 Jul 2005 14:23:35 -0000	1.121
+++ info.c	22 Jul 2005 14:46:33 -0000
@@ -1304,7 +1304,7 @@
 #else
 	prefix[i] = strtok(prefixes, ";");
 #endif /* HAVE_STRTOK_R */
-	while (prefix[i] && i < sizeof(prefix))
+	while (i < 31 && prefix[i])
 #ifdef	HAVE_STRTOK_R
 		prefix[++i] = strtok_r(NULL, ";", &last);
 #else
@@ -1328,7 +1328,7 @@
 #else
 		table_type[i] = strtok(table_types, ",");
 #endif /* HAVE_STRTOK_R */
-		while (table_type[i] && i < 32)
+		while (i < 31 && table_type[i])
 #ifdef	HAVE_STRTOK_R
 			table_type[++i] = strtok_r(NULL, ",", &last);
 #else
@@ -3815,6 +3815,7 @@
 				}
 				if (pkey_alloced)
 					free(pkey_text);
+				pkey_alloced = FALSE;
 				/* Get to next primary key */
 				for (k = 0; k < 2; k++)
 					pkey_ptr += strlen(pkey_ptr) + 1;
